/* Program to implement Euler's method to find a solution for
    a differential equation */

#include<stdio.h>

float f(float x,float y)
 {
   return (x+2*y);
 }

/*-----------------end of function f---------------------------*/
void main()
{
     int i,n;
     float x,y,x0,y0,xx,h;
     clrscr();
     printf("\n enter the initial values x and y ");
     scanf("%f %f",&x0,&y0);
     printf("\n Enter the number of steps  ");
     scanf("%d",&n);
     printf("\n Enter X at which Y is to be evaluated  ");
     scanf("%f",&xx);
     h=(xx-x0)/n;
     printf("\n\t\t The tabulated values :");
     printf("\n\t\t X             Y\n");

     for (i=0;i<n;i++)
     {
	y=y0+h*f(x0,y0);
	printf("\t\t%f %f\n",x0,y0);
	x0=x0+h;
	y0=y;
     }

     printf("\n\n\t\t The approximate value is %f:",y);
     getch();
  }

  /*-------------------end of main---------------------------*/
