/*   Program to implement the false position method.
    Uses the function f.

    Program by: G P Potadr     */


#include<stdio.h>
#include<conio.h>
#include<math.h>


struct fu
{
	float coeff, power;
	float expt, sine, cosine, tn, log;
} fun[10];

float f(float );
int n,i, iter= 0, maxi;
float coeff[10], power[10], slope, x0, x1, x2, error, y0, y1, y2;

/*-----------------end of global declarations----------------------*/

void main()
{
	clrscr();

	printf("Enter total number of terms.\n");
	scanf("%d", &n);

	for(i = 0; i < n ; i ++) /* read the equation */
	{
		printf("Enter coefficient.\n");
		scanf("%f", &coeff[i]);
		printf("Enter power of x.\n");
		scanf("%f", &power[i]);

	}

	/* read the two guess values between which the root may
	   exist */

	printf("Enter guess values .\n");
	scanf("%f %f", &x0,&x1);

	printf("Enter maximum allowable relative error and slope.\n");
	scanf("%f %f", &error, &slope);

	printf("Enter maximum number of iterations.\n");
	scanf("%d", &maxi);

	y0 = f(x0);
	y1 = f(x1);
	if(y0 * y1 < 0)
	{

		for(i = 0; i < maxi; i++)
		{
			y0 = f(x0);
			y1 = f(x1);

			if(fabs(y1 - y0) < slope)
			{
			  printf("Slope too small.\n");
			  getch();
			  exit(0);
			}
			x2 = (x0 * y1 - x1 * y0) / (y1 - y0);
			iter++;
			x0 = x1;
			x1 = x2;

			if (fabs ( (x1-x0)/x1)  < error)
			{
				printf("root of the equation is = %f", x1);
				printf("  Iterations = %d", iter);
				getch();
				exit(0);
			}

		}
	}
	else
	{
		printf("Guess not right. Please check the values \n");
		getch();
	}
}

/*-----------------------------end of main-----------------------------*/

float f(float p)
{
	float z,r = 0;
	for(i = 0; i < n ; i ++)
	{
		z = coeff[i];
		z = z * pow ( p , power[i]);

		r = r + z;
	}
	return(r);
}

/*--------------------end of function f--------------------------------*/



