/* gauss seidal method  */
# include <stdio.h>
# include <conio.h>
# include <math.h>
# define SIZE 3


float a[SIZE][SIZE],cons[SIZE],x[SIZE];

void accept(int n)
{
	int i,j;
	clrscr();
	for ( i = 0; i < n; i++ )
	{
		x[i] = 0;
		clrscr();
		printf("EQUATION NUMBER %d\n\n",(i + 1));
		for ( j = 0; j < n; j++ )
		{
			printf("COEFFICIENT OF X%d : ",(j + 1));
			scanf("%f",&a[i][j]);
		}
		printf("\n\n");
		printf("ENTER THE CONSTANT TERM : ");
		scanf("%f",&cons[i]);
		getch();
	}
}

void display(int n)
{
	int i;
	gotoxy(15,10);
	printf("ROOT");
	gotoxy(30,10);
	printf("VALUE");
	for ( i = 0; i < n; i++ )
	{
		gotoxy(17,12+(2*i));
		printf("X%d",(i + 1));
		gotoxy(31,12+(2*i));
		printf("%.4f",x[i]);
	}
	getch();
}

int g_seid(int n,int no_iter,float err)
{
	int i,j,k,flag;
	float x_old,rel_err,max_err;

	flag = 0;
	for ( i = 0; i < no_iter; i++ )
	{
		max_err = 0;
		for ( j = 0; j < n; j++ )
		{
			x_old = x[j];
			x[j] = cons[j];
			for ( k = 0; k < n; k++ )
			{
				if ( j != k )
					x[j] = x[j] - (a[j][k] * x[k]);
			}
			x[j] = x[j] / a[j][j];
			rel_err = fabs((x[j] - x_old)/x[j]);
			if ( rel_err > max_err )
				max_err = rel_err;
		}
		if ( max_err <= err )
		{
			flag = 1;
			break;
		}
	}
	return(flag);
}

void back_subs(int n)
{
	int i,j;

	x[n - 1] = cons[n - 1] / a[n - 1][n - 1];
	for ( i = (n - 2); i >= 0; i-- )
	{
		x[i] = cons[i];
		for ( j = (n - 1); j > i; j-- )
			x[i] = x[i] - (x[j] * a[i][j]);
		x[i] = x[i] / a[i][i];
	}
}

void main()
{
	int n,no_iter,flag;
	float err;
	clrscr();

	printf("ENTER NUMBER OF VARIABLES : ");
	scanf("%d",&n);
	printf("NUMBER OF ITERATIONS      : ");
	scanf("%d",&no_iter);
	printf("MAXIMUM PERMISSABLE ERROR : ");
	scanf("%f",&err);
	accept(n);
	flag = g_seid(n,no_iter,err);
	if ( flag == 1 )
		display(n);
	else if ( flag == 0 )
	{
		printf("\n\n\n DIVERGENT SOLUTIONS ");
		printf("\n Solution is not Convergent ");
		getch();
	}
}








