
/* Program to find the interpolating value, using
   NEWTON GREGORY BACKWORD DIFFERENCE TECHNIQUE */


 #include<stdio.h>
 #include<math.h>

 main()
 {
  double y[10][10],x[10],xx,yr,h,r,dy,fact;
  int i,j,k,n,m,p;
  clrscr();
  printf("\n Enter the maximum number of terms ..");
  scanf("%d",&n);
  for(i=0;i<n;i++) /* read the table values */
  {
    printf("\n x[%d]",i);
    scanf("%lf",&x[i]);
    printf("\t\t\t y[%d]",i);
    scanf("%lf",&y[i][0]);
  }
  printf("\n Enter the value of x at which value of y is to be interpolated :");
  scanf("%lf",&xx);
  h=x[1]-x[0];
  r=(xx-x[n-1])/h;

  /* Now calculate backward differences */
  k=0;
  for (j=1;j<n;j++)
  {
  k++;
  for (i=n-1;i>=k;i--)
  {
   y[i][j]=y[i][j-1]-y[i-1][j-1];
  }
  }
  /* display the  table */
  printf("\n backward difference table ");
  printf("\n\nX \t   Y \t dy \t d2y \t d3y \t d4y \t d5y \t d6y \t d7y \t d8y");
  printf("\n");
  for(i=0;i<n;i++)
  {
   printf("%4.2f  ",x[i]);
   for(j=0;j<i+1;j++)
    printf("  %4.2f",y[i][j]);
  printf("\n");
  }

  /* calculation of interpolating value */

  yr=0;
  for(p=1;p<n;p++)
  {
  dy=1;
  fact=1;
  for(m=0;m<p;m++)
  {
  dy=dy*(r+m);
  fact=fact*(m+1);
  }
  dy=dy*(y[n-1][p]/fact);
  yr=yr+dy;
  }
  yr=yr+y[n-1][0];

  printf("\nThe interpolated value at %8.5f is..%8.5f",xx,yr);
  }

  /*-------------------end of main-----------------------------*/
