/* Program to find the interpolating value, using
   NEWTON'S DIVIDED DIFFERENCES INTERPOLATION   METHOD */


 #include<stdio.h>
 #include<math.h>
 #define MAX 10  /* maximum allowable entries */

 /*----------------end of declarations --------------------------*/

 main()
 {
  double y[MAX][MAX],x[MAX],xx,sum,h,r,dy,fact;
  int i,j,k,n,m,p;
  clrscr();
  printf("\n Enter the maximum number of terms ..");
  scanf("%d",&n);
  if (n >MAX )
   {
     printf("\n... You can not exceed the limit ...");
     getch();
   }
   else
   {
     for (i=0;i<MAX;i++)  /*initialise y values to zero */
      for(j=0;j<MAX;j++)
	  y[i][j]=0;

   for(i=0;i<n;i++) /* read the table values */
   {
    printf("\n x[%d]",i);
    scanf("%lf",&x[i]);
    printf("\t\t\t y[%d]",i);
    scanf("%lf",&y[i][0]);
   }
   printf("\n Enter the value of x at which value of y is to be interpolated :");
   scanf("%lf",&xx);
   k=n;
   for (j=1;j<n;j++)
   {
     k--;
     for(i=0;i<k;i++)
     {
       y[i][j]=(y[i+1][j-1]-y[i][j-1])/(x[i+j]-x[i]);
     }
   }

   k=n;
  /* display the  table */
  printf("\n divided difference table ");
  printf("\n\nX \t   Y \t dy \t d2y \t d3y \t d4y \t d5y \t d6y \t d7y \t d8y");
  printf("\n");
  for(i=0;i<n;i++)
  {
   printf("%5.2f  ",x[i]);
   for(j=0;j<k-i;j++)
    printf("  %5.2f",y[i][j]);
     printf("\n");
   }

  /* calculation of interpolating value */
  sum=0;
  for(p=1;p<n;p++)
  {
     dy=1;
     for(m=0;m<p;m++)
    {
     dy=dy*(xx-x[m]);
    }
   sum=sum+(dy*y[0][p]);
  }
    sum=sum+y[0][0];
    printf("\nThe interpolated value at %8.5f is..      %8.5f",xx,sum);
 } /* end of else */
} /* end of main*/
  /*-------------------end of main-----------------------------*/
