/*   Program to implement Newton Raphson method.
     The function and the derivative functions are hardcoded.

     Program By :G.P Potdar                                   */


#include<stdio.h>
#include<math.h>
#include<conio.h>


float x0, x1, fx0, f_x0 , error, delta, n;
int i;
float fdash(float );
float f(float );

/*----------------end of global declarations-------------------------*/

void main()
{       char ans;
	do
	{
	clrscr();
	printf("Enter initial guess :");
	scanf("%f",&x0);
	printf("\n Enter the allowable error : ");
	scanf("%f",&error);
	printf("\n Enter  delta ");
	scanf("%f",&delta);
	printf("\n Enter the number of iterations :");
	scanf("%d",&n);

	for (i = 0;i < n; i++)
	{

		fx0 = f(x0);
		f_x0 = fdash(x0);

		if(fabs(f_x0) <= delta)
		{
			printf("slope too small.\n");
			getch();
			exit(0);
		}
		x1 = x0 - fx0/f_x0;
		if(fabs( (x1 - x0)/x1 ) < error )
		{
			printf("Root = %f no of iterations : %d", x1,i);
			getch();
			exit(0);

		}
		x0 = x1;
	}
		printf("Root = %f no of iterations : %d", x1,i);
		getch();
	 printf("\n Do you wish to try again (y/n) ? ");
	 ans=getch();
	 }while (ans=='y');

}

/*-------------------------end of main program------------------------*/

float f(float p)
/* function to define the given function */

{
	return(p*p*p*p-p-10);

}
/*-----------------end of function f--------------------------------*/


float fdash(float p)

/* function to find the derivative of f  */
{
	return(3*p*p*p-1);

}
/*-----------------end of function fdash-----------------------------*/