

    { Program : Implementation of BISECTION method to find the roots
                of algebraic equations.

      Program by : Mrs Shivangi Girish. Potdar.}

{------------------------------------------------------------------------}

      PROGRAM BISECT(INPUT,OUTPUT);
      VAR a,b:REAL;   {Initial guess vakues }

      maxerr:REAL;    {Maximum tollerable error}

      maxitr:INTEGER;  {Maximum number of iterations to be performed}
      no_itr:INTEGER;  {Counter to keep track of number of iterations}

      f0,f1,f2:REAL;  {  temporary variables to hold the values returned
                         by the function.
                         Viz, f0=F(a), f1:=F(b), f2=(F(a+b)/2)  }

      mid_val:REAL;   { Variable to store the bisection value }

{----------------------End of Declaration part----------------------------}

      FUNCTION F(X:REAL):REAL;  { Function whose roots are to be found
                                  Make the changes to the function if
                                  required }

      BEGIN
          F:=X*X-4;  {Here we are finding the roots of equation X^2-4=0}
      END;
{---------------------End of function F----------------------------------}

      BEGIN {Main program}
           clrscr;
           WRITE('Enter The initial Guess values of the root : ');
           READLN(a,b);
           WRITE('Enter The tollerable Error :');
           READLN(maxerr);
           WRITE('Enter The Maximum Number of iterations to be performed  : ');
           READLN(maxitr);
           writeln('--------------------------------------------------');
           f0:=F(a); { Compute function value for "a"}
           f1:=F(b); {Compute function value for "b"}
           IF(f0*f1>0) THEN  { Check for incorrect starting values }
            Begin
               WRITELN('INCORRECT INITIAL VALUES : ');
               WRITELN('a = ',a,' b = ',b,' F(a)=',f0,'F(b) = ',f1)

            End
           ELSE
            Begin
               no_itr:=0; {Initialise the number of iterations performed }
                     writeln('   a       b      mid_val      F(a)     F(b)        F(mid_val)     Iterations');

               REPEAT
                     mid_val:=(a+b)/2;

                     f2:=F(mid_val); { Calculate the function value at mid_val}
                     write(a:7:4,' ',b:7:4,'  ',mid_val:7:4,'      ',f0:7:4,'  ',f1:7:4,' ','      ',f2:7:4);
                     writeln('         ',no_itr);

                     {Check the range of possible existance of the root.
                       That is if f2 is -ve then root lies between mid_val and
                       "b" otherwise root is between "a" and mid_val }

                     IF(f0*f2 > 0) THEN
                           a:=mid_val
                     ELSE
                           b:=mid_val;
                     no_itr:=no_itr+1      ;
               UNTIL(ABS((b-a)/b)<=maxerr) OR(no_itr>=maxitr);
               writeln('-----------------------------------------------------');
             IF(no_itr>=maxitr) THEN  {Check whether root is found within the
                                 specified number of iterations }
             Begin
                WRITELN('Does not Converge in ',maxitr,' iterations');
             END
             ELSE
               begin
                   WRITELN('ROOT=',mid_val:7:4);
               end;
            End;
        END.

{----------------------------End of MAin Program--------------------------}

