{ Program to implement Golden section method }

  program gol;
  var
    y,x1,x2,x3,xlow,es,xhigh :real;
    i,maxiter                :integer;

    s0,f1,f2                 :real;
    f20:text;
{---------------------end of declarations----------------------}

function f(x:real):real;
{function to accept the user function}
begin
{  f:=2*x-1.75*(x*x)+1.1*(x*x*x*x)-0.25*(x*x*x*x);}
    f:=x*(y*y-x*x)
end;
{------------------end of function f-------------------------}
function gold(xlow,xhigh:real;es:real;maxiter:integer):real;

{main routine for golden section }
var
   xl,xu,ea,fx,xopt,r,d,f1,f2fx:real;
   iter,i                      :integer;

begin
     assign(f20,'gold1.out');rewrite(f20);
     r:=(sqrt(5)-1)/2;
     xl:=xlow;
     xu:=xhigh;
     iter:=1;
     d:=r*(xu-xl);
     x1:=xl+d;
     x2:=xu-d;
     f1:=f(x1);
     f2:=f(x2);
      writeln(f20,'  x1        f(x1)      x2     f(x2)     d');
      writeln(f20,x1:8:5,' ',f(x1):8:5,' ',x2:8:5,' ',f(x2):8:5,' ',d:8:5);
      if(f1>f2) then
      begin
         xopt:=x1;
         fx:=f1;
      end
      else
      begin
        xopt:=x2;
        fx:=f2;
     end;
     repeat
        writeln(f20,x1:8:5,' ',f(x1):8:5,' ',x2:8:5,' ',f(x2):8:5,' ',d:8:5);
         d:=r*d;
         if(f1>f2) then
         begin
              xl:=x2;
              x2:=x1;
              x1:=xl+d;
              f2:=f1;
              f1:=f(x1);
         end
         else
         begin
              xu:=x1;
              x1:=x2;
              x2:=xu-d;
              f1:=f2;
              f2:=f(x2);
         end;
      iter:=iter+1;
      if f1 > f2 then
      begin
           xopt :=x1;
           fx:=f1;
      end
      else
      begin
           xopt:=x2;
           fx:=f2;
      end;
      ea :=(1-r)*abs((xu-xl)/xopt)*100;

    until((ea<=es) or (iter >=maxiter));
    gold:=xopt;
 end;

{-------------------end of function gold----------------------------}

begin {main}
clrscr;
      write('enter xlow and xhigh');
      readln(xlow,xhigh);
      write('enter allowable error ');
      readln(es);
      write('enter maximum iterations :');
      readln(maxiter);
      y:=gold(xlow,xhigh,es,maxiter);
      writeln(f20,'The convergent value is ',y:8:5);
      close(f20);

end.
{-----------------end of main-------------------------------------}


