{ Program to find the interpolating value, using
   NEWTON'S DIVIDED DIFFERENCES INTERPOLATION   METHOD }

const
    MAX = 10;
var
   y:array [0..MAX,0..MAX] of real;
   x:array[0..MAX] of real;
   xx,sum,h,r,dy,fact:real;
   i,j,k,n,m,p:integer;

 Begin

  clrscr;
  write(' Enter the maximum number of terms ..');
  readln(n);
  if (n >MAX ) then
   Begin
     writeln('... You can not exceed the limit ...');
     readln;
   end
   else
   Begin
     for i:=0 to MAX do  {initialise y values to zero }
      for j:=0 to MAX do
         y[i,j]:=0;

   for i:=0 to n-1 do { read the table values }
   Begin
    write('':10,'x[',i,']');
    readln(x[i]);
    write('':10,'y[',i,']');
    readln(y[i,0]);
   end;
   write(' Enter the value of x at which value of y is to be interpolated :');
   readln(xx);
   k:=n;
   for j:=1 to n-1 do
   Begin
     k:=k-1;
     for i:=0 to k-1 do
     Begin
       y[i,j]:=(y[i+1,j-1]-y[i,j-1])/(x[i+j]-x[i]);
     end;
   end;

   k:=n;
  { display the  table }
  writeln(' divided difference table ');
  writeln('X      Y    dy    d2y   d3y   d4y   d5y  d6y  d7y   d8y');
  writeln;
  for i:=0 to n-1 do
  Begin
   write(' ',x[i]:8:5);
   for j:=0 to k-i do
    write('  ',y[i,j]:8:5);
     writeln('');
   end;

  { calculation of interpolating value }
  sum:=0;
  for p:=1 to n-1 do
  Begin
     dy:=1;
     for m:=0 to p-1 do
    Begin
     dy:=dy*(xx-x[m]);
    end;
   sum:=sum+(dy*y[0,p]);
  end;
    sum:=sum+y[0,0];
    writeln('The interpolated value at',xx:8:5,'  is..      ',sum:8:5);
 end; { end of else }
end. { end of main}
  {-------------------end of main-----------------------------}
