{ Program to find integral of a function using
  Simpson's 3/8th rule }

program simp38;

var
    i,n   :integer;
    x     :array[0..20] of real;
    y     :array[0..20] of real;
    h,area:real;
    f1:text;
{----------------------end of declarations--------------------------}

begin {main}
      clrscr;
      assign(f1,'simp8.out');
      rewrite(f1);
      writeln('enter total number of data points');
      readln(n);
      writeln('enter first and last data points:');
      readln(x[0],x[n]);

      h:=(x[n]-x[0])/(n-1);
      for i:=1 to n-1 do
          x[i]:=x[i-1]+h;
      area:=0;

      for i:= 0 to n do
           y[i]:=sin(x[i]*3.142/180)-ln(x[i])+exp(x[i]);
      area:=y[0]+y[n];

      i:=1;
      while(i<n-1) do
      begin
          if (i mod 3 <> 0) then
            area:=area+3*(y[i])
          else
            area:=area+2*y[i];
          i:=i+1
      end;

     area:=(3*h/8)*(area);
     writeln(f1,' THE TABLE VALUES COMPUTED ARE ');
     writeln(f1,'-------------------------------');
     writeln(f1,'----------------------------------------------------');
     write(f1,'X ');
     for i:=0 to n-1 do
     begin
      write(f1,x[i]:5:4,' ')
     end;
     writeln(f1);
     write(f1,'Y ');
     for i:=0 to n-1 do
     begin
      write(f1,y[i]:5:4,' ')
     end;
     writeln(f1);
     writeln(f1,'-------------------------------------------------');

     writeln(f1,' Integral is :',area:8:5);
     readln;
     close(f1);
     readln;

   end.

{----------------------------end of main program------------------}


