/* Program to implement bisection method */

#include<stdio.h>
#include<conio.h>
#include<math.h>

float f(float );

float x0, x1, x2, coeff[10], error;
int i, j, iterations = 0;

/*------------end of declarations -------------------------*/

void main()
{

	clrscr();

	printf("Enter total number of terms.\n");
	scanf("%d", &j);

	for(i = j - 1;i >= 0; i--)
	{
		printf("Enter coefficient.\n");
		scanf("%f", &coeff[i]);
	}

	printf("Enter two guesses.\n");
	scanf("%f%f", &x0, &x1);

	if(f(x0) == 0)
	{
		printf(" Root = %f",x0);
		getch();
		exit();
	}

	if(f(x1) == 0)
	{
		printf(" Root = %f",x1);
		getch();
		exit();
	}

	printf("Enter max. allowable relative error.\n");
	scanf("%f", &error);

	if(f(x0) * f(x1) <= 0)
		while( fabs ( (x1-x0)/x1 ) > error)
		{
			x2 = (x1+x0) / 2;

			if(f(x0) * f(x2) <= 0)
				x1 = x2;
			else
				x0 = x2;
			iterations++;
		}

	else
	{
		printf("Wrong initial guesses.\n");
		getch();
		exit();
	}

	printf("Roots = %f ",x1);
	printf("iterations = %d", iterations);
	getch();

}

/*-----------------------end of main program----------------------*/

float f(float p)
{
	float sum = 0;

	for(i = j;i >= 0; i--)
		sum = sum + coeff[i] * pow (p,i);
	return(sum);
}


/*-------------------end of function f-----------------------------*/

