/* Program to implement Modified Euler's method to find a solution for
    a differential equation */

#include<stdio.h>

float f(float x,float y)
 {
   return (x+3*y);
 }

/*-----------------end of function f---------------------------*/
void main()
{
     int i,n;
     float xold,yold,xnew,ynew,ynew1,x0,y0;
     float xx,h;
     clrscr();

     printf("\n enter the initial values x and y ");
     scanf("%f %f",&x0,&y0);

     printf("\n Enter X at which Y is to be evaluated  ");
     scanf("%f",&xx);
     printf("\n Enter the step size  ");
     scanf("%f",&h);
     n=(xx-x0)/h;

     printf("\n\t\t The tabulated values :");
     printf("\n\t\t X             Y\n");

     for (i=0;i<=n;i++)
     {
	xold=x0;
	yold=y0;
	ynew=yold+h*f(xold,yold);   /* predictor formula */
	xnew=xold+h;
	do
	{
	 ynew1=ynew;		   /* corrector formula */
	 ynew=yold+h/2*(f(xold,yold)+f(xold+h,ynew1));
	 }while (abs(ynew1-ynew) >0.001);
	x0=xnew;
	y0=ynew;
	printf("\t\t%f %f\n",xnew,ynew);
	}

     printf("\n\n\t\t The approximate value is : %f",ynew);
     getch();
  }

  /*-------------------end of main---------------------------*/
