/* Program to fit a second degree parabola using Least square
   method .
   Use the notation as mentiond here :
	  d1 = Yi
	  e1 = Xi
	  f1 = Xi^2
	  g1 = XiYi
	  h1 = Xi ^ 3
	  i1 = Xi^2 Yi
	  j1 = Xi^4

   To solove for a,b,c, we have used the cramer's rule.
       i.e, dx=b1f1j1 +e1h1i1+f1g1h1-i1f1^2-h1^2d1-j1g1e1
	    dy=n1g1j1+d1h1f1+f1e1i1-f1^2g1-i1h1n-j1e1d1
	    dz=n1f1i1+e1g1f1+d1e1h1-f1^2d1-h1g1n-e1^i
	    dd=n1f1j1+e1h1f1+f1e1h1-f1^3-h1^2n-j1e1^2

	    a=dx/dd, b=du/dd c=dz/dd

   (Refer to the algorithm given in the text )

							      */


#include<stdio.h>
#include<math.h>

/*-----------------------end of declarations--------------------------*/

void main()

{
	int n, i;
	float x, y, a0, a1 ;
	float d1,e1,f1,g1,h1,i1,j1;
	float a,b,c;
	float dx,dy,dz,dd;
	char ch;



	clrscr();
	printf("Enter total number of points.\n");
	scanf("%d", &n);
	d1=0;
	e1=0;
	f1=0;
	g1=0;
	h1=0;
	i1=0;
	j1=0;

	for(i = 0;i < n;i++)
	{
		printf("Enter x and y \n");
		scanf("%f%f",&x,&y);
		e1 += x;
		d1 += y;
		g1 += x*y;
		f1 += x*x;
		h1 += x*x*x;
		i1 += x*x*y;
		j1 += x*x*x*x;
	}
		dx =f1*(d1*j1+g1*h1-i+f1)+h1*(e1*i1 - h1*d1)-j1*g1*e1;
		dy =g1*(n*j1- f1*f1)+h1*(d1*f1-i1*n)+e1*(f1*i1-j1*d1);
		dz = f1*(n*i1+e1*g1-f1*d1)+h1*(d1*e1-g1*n)-e1*e1*i1;
		dd=n*f1*j1+2*e1*h1*f1 -f1*f1*f1-h1*h1*n-j1*e1*e1;

		a=dx/dd;
		b=dy/dd;
		c=dz/dd;

		printf("Y = %f + %fX + %fX^2 .",a,b,c);

	getch();

}


/*----------------------end of main------------------------------------*/