/* Program to implement secant method .
   Program uses only a single function f to input the user function.
   This function is also hard coded.				*/


#include<stdio.h>
#include<math.h>
#include<conio.h>

float f(float );
/*-------------------end of global declarations-----------------------*/

void main()
{
	int n, i;
	float x0,x1,x2,fx0,fx1,fx2,error,delta;

	clrscr();
	printf("\n\n\t\t\t SECANT METHOD \n");
	printf("\n\n\t\t\t -------------\n\n");
	printf("\t\tEnter two guesses.");
	scanf("%f%f", &x0,&x1);

	printf("\n\t\t Enter lower bound slope. ");
	scanf("%f", &delta);

	printf("\n\t\tEnter allowable relative error. ");
	scanf("%f", &error);

	printf("\n\t\tEnter maximum number of iterations. ");
	scanf("%d", &n);
	printf("\n\t\t X0          X1        F(X0)         F(X1) ");
	for (i = 1;i < n;i++)
	{
		fx0 = f(x0);
		fx1 = f(x1);

		if(fabs (fx1 - fx0) < delta)
		{
			printf("\n\t\t Slope too small. ");
			getch();
			exit(0);
		}
		x2 = (x0*fx1 - x1*fx0) / (fx1 - fx0);
		fx2 = f(x2);
		printf("\n\t\t%f   %f  %f  %f",x0,x1,fx0,fx1);
		getch();
		x0 = x1;
		x1 = x2;
		fx0 = fx1;
		fx1 = fx2;

		if(fabs ((x1 - x0)/x1) < error)
		{

			printf("\n\t\t Convergent solution.  ");
			printf("\n\t\t Root = %f\n", x0);
			printf("\n\t\t No. of iterations  = %d", i);
			getch();
			exit(0);
		}

	}


	printf("\n\t\t Doesn't converge in n iterations.\n");
	getch();


}

/*-------------------------end of main program-----------------------*/

float f(float p)
/* function to define the user equation */

{
	return(cos(p)-p*exp(p));
	return(p*p-25);

}

/*--------------------end of function f-----------------------------*/



