
{ Program to find the interpolating value, using
   NEWTON GREGORY BACKWORD DIFFERENCE TECHNIQUE }
program Greg_newt;
const
    max = 10;
var
  y:array[0..max,0..max] of real;
  x:array[0..max] of real;
  xx,yr,h,r,dy,fact:real;
  i,j,k,n,m,p:integer;
 begin

  clrscr;
  write(' Enter the maximum number of terms ..');
  readln(n);
  for i:=0 to n-1 do  { read the table values }
  begin
    write('x[',i,']');
    readln(x[i]);
    write('':5,'y[',i,']');
    readln(y[i,0]);
  end;
  write('Enter the value of x at which value of y is to be interpolated :');
  readln(xx);
  h:=x[1]-x[0];
  r:=(xx-x[n-1])/h;

  { Now calculate backward differences }
  k:=0;
  for j:=1 to n-1 do
  begin
  k:=k+1;
  for i:=n-1 downto k do
  begin
   y[i,j]:=y[i,j-1]-y[i-1,j-1];
  end;
  end;
  { display the  table }
  writeln('\n backward difference table ');
  writeln('X    Y    dy   d2y    d3y    d4y   d5y   d6y  d7y   d8y');
  for i:=0 to n-1 do
  begin
   write(x[i]:4:2);
   for j:=0 to i do
    write('  ',y[i,j]:5:3);
  writeln;
  end;

  { calculation of interpolating value }

  yr:=0;
  for p:=1 to n-1 do
  begin
  dy:=1;
  fact:=1;
  for m:=0 to p-1 do
  begin
  dy:=dy*(r+m);
  fact:=fact*(m+1);
  end;
  dy:=dy*(y[n-1,p]/fact);
  yr:=yr+dy;
  end;
  yr:=yr+y[n-1,0];

  writeln('The interpolated value at ',xx:8:5,'is  ',yr:8:5);
  end.

  {-------------------end of main-----------------------------}
