{ Program to find the integral of a given function
  using trapezoidal rule }


program trapezoid;

var
   i,n         :integer;
   x           :array[1..20] of real;
   y           :array[1..20] of real;
   h,area,nn   :real;

{-----------------------end of declarations ---------------------}

begin {main}
    clrscr;
    writeln('':10,'enter total number of data points');
    readln(n);
    writeln('':10,'enter first and last data points:');
    readln(x[1],x[n]);
    h:=(x[n]-x[1])/(n-1);

    for i:=2 to n-1 do
        x[i]:=x[i-1]+h;
    area:=0;

    for i:= 1 to n do
        y[i]:=1/(1+x[i]);   {compute Y values at given X}
    writeln;
    writeln;

    writeln(' VALUES OF X AND CORRESPONDING Y VALUES ARE :');
    writeln('------------------------------------------------------------');
    WRITE('X  ');
    for i:=1 to n do
       write(x[i]:5:3,'  ');
   writeln;
   WRITE('Y  ');
   for i:=1 to n do
      write(y[i]:5:3,'  ');
   writeln;
   writeln('-------------------------------------------------------------');


    for i:=2 to n-1 do
        area:=area+2*y[i];
    area:=(h/2)*(area+y[1]+y[n]);
    writeln('Integral = ',area:9:5);
    readln;

  end.


{-----------------------end of main program----------------------------}
